SystemOrganization addCategory: #'SqueakSource2-Core'!
SystemOrganization addCategory: #'SqueakSource2-Tests'!
SystemOrganization addCategory: #'SqueakSource2-View'!

!Object methodsFor: '*squeaksource2-view' stamp: 'lr 8/19/2008 11:39'!
s2root
	^ S2Root default! !

Object subclass: #S2Entry
	instanceVariableNames: 'name title wiki tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionName
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 100;
		beRequired;
		yourself! !

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionTags
	^ MATokenDescription new
		accessor: #tags;
		priority: 130;
		label: 'Tags';
		yourself! !

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 110;
		label: 'Title';
		beRequired;
		yourself! !

!S2Entry class methodsFor: 'accessing-description' stamp: 'lr 7/9/2008 14:32'!
descriptionWiki
	^ MAMemoDescription new
		accessor: #wiki;
		priority: 120;
		label: 'Wiki';
		yourself! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:41'!
addTag: aTag
	tags add: aTag! !

!S2Entry methodsFor: 'initialization' stamp: 'AQ 7/6/2008 17:38'!
initialize
	super initialize.
	tags := Set new.! !

!S2Entry methodsFor: 'testing' stamp: 'lr 7/7/2008 14:36'!
isEditableBy: aUser
	self subclassResponsibility! !

!S2Entry methodsFor: 'testing' stamp: 'lr 7/7/2008 14:36'!
isVisibleBy: aUser
	self subclassResponsibility! !

!S2Entry methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:31'!
name
	^ name! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:37'!
name: aString 
	name := aString! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/7/2008 11:37'!
removeTag: aTag
	tags remove: aTag! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 6/18/2008 17:56'!
tags
	^tags! !

!S2Entry methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:33'!
tags: aCollection
	tags := aCollection! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 6/30/2008 10:56'!
title
	^title! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:39'!
title: aString
	title := aString! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 6/18/2008 17:56'!
wiki
	^wiki! !

!S2Entry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:37'!
wiki: anObject
	wiki := anObject! !

S2Entry subclass: #S2Member
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

S2Member subclass: #S2Group
	instanceVariableNames: 'users admins'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
addAdmin: aUser
	admins add: aUser.
	aUser groups add: self! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:30'!
addUser: aUser
	users add: aUser.
	aUser groups add: self! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
admins
	^ admins! !

!S2Group methodsFor: 'initialization' stamp: 'AQ 7/9/2008 12:14'!
initialize
	super initialize.
	users := Set new.
	admins := Set new.! !

!S2Group methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:22'!
isEditableBy: aUser
	^ aUser superuser or: [admins includes: aUser].! !

!S2Group methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:34'!
isVisibleBy: aUser
	^ aUser superuser or: [admins includes: aUser] or: [users includes: aUser].! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
removeAdmin: aUser
	admins remove: aUser.
	aUser groups remove: self! !

!S2Group methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:47'!
removeUser: aUser
	users remove: aUser.
	aUser groups remove: self! !

!S2Group methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:46'!
users
	^ users! !

S2Member subclass: #S2Person
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

S2Person subclass: #S2AnonymousUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2AnonymousUser methodsFor: 'as yet unclassified' stamp: 'lr 7/9/2008 14:22'!
initialize
	super initialize.
	name := 'Ananymous'.! !

!S2AnonymousUser methodsFor: 'testing' stamp: 'lr 8/19/2008 11:28'!
isAnonymous
	^ true! !

!S2Person class methodsFor: 'accessing-description' stamp: 'lr 9/2/2008 11:07'!
descriptionName
	^ super descriptionName label: 'Initials'! !

!S2Person class methodsFor: 'accessing-description' stamp: 'AQ 9/5/2008 16:28'!
descriptionTitle
	^ super descriptionTitle label: 'Name'! !

!S2Person methodsFor: 'testing' stamp: 'lr 8/19/2008 11:27'!
isAnonymous
	^ false! !

!S2Person methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:42'!
superuser
	^ false! !

S2Person subclass: #S2User
	instanceVariableNames: 'email password groups superuser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2User class methodsFor: 'accessing-description' stamp: 'AQ 7/14/2008 14:41'!
descriptionEmail
	^ MAStringDescription new
		accessor: #email;
		label: 'Email';
		priority: 140;
		beRequired;
		yourself! !

!S2User class methodsFor: 'accessing-description' stamp: 'AQ 7/14/2008 14:42'!
descriptionPassword
	^ MAStringDescription new
		accessor: #password;
		label: 'Password';
		priority: 150;
		beRequired;
		yourself! !

!S2User class methodsFor: 'accessing-description' stamp: 'lr 8/19/2008 11:51'!
descriptionSuperuser
	^ MABooleanDescription new
		accessor: #superuser;
		label: 'Superuser';
		priority: 160;
		yourself! !

!S2User methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:46'!
addGroup: aGroup
	groups add: aGroup.
	aGroup users add: self! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email
	^ email! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email: anObject
	email := anObject! !

!S2User methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
groups
	^ groups! !

!S2User methodsFor: 'private' stamp: 'lr 7/9/2008 15:01'!
hashPassword: aString 
	^ aString isEmptyOrNil ifFalse: [ SecureHashAlgorithm new hashMessage: aString ]! !

!S2User methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:41'!
initialize
	super initialize.
	superuser := false.
	groups := Set new! !

!S2User methodsFor: 'testing' stamp: 'AQ 7/9/2008 11:49'!
isEditableBy: aUser
	^ (aUser = self or: [aUser superuser]).! !

!S2User methodsFor: 'testing' stamp: 'lr 8/19/2008 11:31'!
isVisibleBy: aUser
	^ (aUser isAnonymous not).! !

!S2User methodsFor: 'accessing' stamp: 'AQ 7/14/2008 14:47'!
password
	^ password! !

!S2User methodsFor: 'accessing' stamp: 'lr 7/9/2008 15:01'!
password: aString 
	password := self hashPassword: aString! !

!S2User methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:47'!
removeGroup: aGroup
	groups remove: aGroup.
	aGroup users remove: self! !

!S2User methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:41'!
superuser
	^ superuser! !

!S2User methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:42'!
superuser: aBoolean
	superuser := aBoolean! !

!S2User methodsFor: 'testing' stamp: 'lr 7/9/2008 15:02'!
verifyPassword: aString
	^ (self hashPassword: aString) = password! !

S2Entry subclass: #S2Project
	instanceVariableNames: 'license state rating visibility admins developers repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:00'!
addAdmin: aUserOrGroup
	admins add: aUserOrGroup.! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:00'!
addDeveloper: aUserOrGroup
	developers add: aUserOrGroup.! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
admins
	^ admins! !

!S2Project methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:39'!
developers
	^ developers! !

!S2Project methodsFor: 'initialization' stamp: 'lr 9/2/2008 11:50'!
initialize
	super initialize.
	developers := Set new.
	admins := Set new.
	rating := 0.
	visibility := #hidden.
	state := 'Created'.! !

!S2Project methodsFor: 'testing' stamp: 'AQ 7/9/2008 12:50'!
isEditableBy: aUser
	^ aUser superuser or: [admins includes: aUser].! !

!S2Project methodsFor: 'testing' stamp: 'lr 8/19/2008 11:30'!
isVisibleBy: aUser
	^ aUser superuser or: [admins includes: aUser] or: [developers includes: aUser] or: [visibility = #visible].! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
license
	^ license! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
license: anObject
	license := anObject! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating
	^ rating! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating: anObject
	rating := anObject! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:04'!
removeAdmin: aUserOrGroup
	admins remove: aUserOrGroup.! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:05'!
removeDeveloper: aUserOrGroup
	developers remove: aUserOrGroup.! !

!S2Project methodsFor: 'accessing' stamp: 'lr 9/2/2008 11:51'!
repository
	^ repository
		ifNil: [repository := MDMemoryRepository named: self name]! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
state
	^ state! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
state: anObject
	state := anObject! !

!S2Project methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:56'!
visibility
	^ visibility
	
"
#hidden
#visible
#writeable
"! !

!S2Project methodsFor: 'accessing' stamp: 'lr 7/7/2008 14:35'!
visibility: aCaracter
	visibility := aCaracter

"
#hidden
#visible
#writeable
"
! !

S2Entry subclass: #S2Root
	instanceVariableNames: 'anonymous users groups projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Core'!

S2Root class
	instanceVariableNames: 'Default'!

S2Root class
	instanceVariableNames: 'Default'!

!S2Root class methodsFor: 'accessing' stamp: 'lr 7/7/2008 14:29'!
default
	^ Default! !

!S2Root class methodsFor: 'initialization' stamp: 'lr 7/7/2008 14:29'!
initialize
	Default := self new! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addGroup: aGroup
	groups add: aGroup! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addProject: aProject
	projects add: aProject! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addUser: aUser
	users add: aUser! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 8/20/2008 14:58'!
anonymous
	^ anonymous! !

!S2Root methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:35'!
countProjectsOfUser: aUser 
	^ self projects
		count: [:project | (project admins includes: aUser)
				or: [project developers includes: aUser]]! !

!S2Root methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:45'!
getGroupsOfUser: aUser 
	^ self groups
		select: [:group | (group admins includes: aUser)
				or: [group users includes: aUser]]! !

!S2Root methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:43'!
getProjectsOfUser: aUser 
	^ self projects
		select: [:project | (project admins includes: aUser)
				or: [project developers includes: aUser]]! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:41'!
groups
	^ groups! !

!S2Root methodsFor: 'querying' stamp: 'AQ 9/5/2008 16:23'!
groupsOfUser: aUser 
	^ self groups
		select: [:eachGroup | (eachGroup admins includes: aUser)
				or: [eachGroup users includes: aUser]]! !

!S2Root methodsFor: 'initialization' stamp: 'AQ 8/20/2008 14:59'!
initialize
	super initialize.
	anonymous := S2AnonymousUser new.
	users := Set new.
	projects := Set new.
	groups := Set new.! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:42'!
projects
	^ projects! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:37'!
removeGroup: aGroup
		groups remove: aGroup! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:52'!
removeProject: aProject
		projects remove: aProject! !

!S2Root methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:51'!
removeUser: aUser
		users remove: aUser! !

!S2Root methodsFor: 'querying' stamp: 'lr 8/19/2008 11:08'!
userNamed: aString
	^ self users detect: [ :each | each name = aString ] ifNone: [ nil ]! !

!S2Root methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:36'!
users
	^ users! !

WAComponent subclass: #S2Component
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2Component class methodsFor: 'instance creation' stamp: 'AQ 9/2/2008 01:39'!
on: aComponent
	^ self new initializeOn: aComponent! !

!S2Component methodsFor: 'initialization' stamp: 'AQ 9/2/2008 01:37'!
initializeOn: aComponent
	root := aComponent! !

!S2Component methodsFor: 'accessing' stamp: 'AQ 9/2/2008 01:37'!
root
	^ root! !

!S2Component methodsFor: 'accessing' stamp: 'AQ 9/2/2008 01:37'!
user
	^ self session user! !

S2Component subclass: #S2ContentComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

S2ContentComponent subclass: #S2GroupView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2GroupView methodsFor: 'actions' stamp: 'AQ 9/2/2008 19:18'!
delete: aGroup 
	self s2root removeGroup: aGroup! !

!S2GroupView methodsFor: 'editing' stamp: 'AQ 9/2/2008 19:18'!
edit
	self call: (group asComponent addValidatedForm; addMessage: 'Edit Group'; yourself)! !

!S2GroupView methodsFor: 'accessing' stamp: 'AQ 9/2/2008 18:26'!
group
	^ group! !

!S2GroupView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:40'!
group: aGroup 
	group := aGroup! !

!S2GroupView methodsFor: 'rendering' stamp: 'AQ 9/3/2008 13:41'!
renderContentOn: html 
	html heading: group title , ' Group'.
	(self group isEditableBy: self session user)
		ifTrue: [html anchor
				callback: [self edit];
				 with: 'Edit'.
			html break.
			html anchor
				callback: [self delete: self group];
				 with: 'Delete']! !

S2ContentComponent subclass: #S2GroupsView
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2GroupsView methodsFor: 'accessing' stamp: 'AQ 9/2/2008 18:20'!
children
	^ Array with: view! !

!S2GroupsView methodsFor: 'initialization' stamp: 'AQ 9/3/2008 13:41'!
initialize
	super initialize.
	view := S2GroupView on: self! !

!S2GroupsView methodsFor: 'rendering' stamp: 'AQ 9/6/2008 12:17'!
renderContentOn: html 
	html heading: 'Groups'.
	view group isNil
		ifTrue: [html
				table: [html
						tableHead: [html tableHeading: 'Groupname';
								 tableHeading: 'Admins';
								 tableHeading: 'Member';
								 tableHeading: 'Tags'].
					self s2root groups
						do: [:each | html
								tableRow: [html
										tableData: [html anchor
												callback: [self viewGroup: each];
												 with: each title].
									html
										tableData: [each admins
												do: [:ea | html text: ea name]].
									html
										tableData: [each users
												do: [:ea | html text: ea name]].
									html
										tableData: (each tags)]]]]
		ifFalse: [html render: view]! !

!S2GroupsView methodsFor: 'actions' stamp: 'AQ 9/3/2008 13:41'!
viewGroup: aGroup 
	view group: aGroup! !

S2ContentComponent subclass: #S2HelpView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2HelpView methodsFor: 'rendering' stamp: 'AQ 9/3/2008 13:42'!
renderContentOn: html 
	html heading: 'Help'.
	html text: 'This is a Help Site.'! !

S2ContentComponent subclass: #S2MembersView
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2MembersView methodsFor: 'accessing' stamp: 'AQ 9/2/2008 09:58'!
children
	^ Array with: view! !

!S2MembersView methodsFor: 'initialization' stamp: 'AQ 9/3/2008 13:42'!
initialize
	super initialize.
	view := S2UserView on: self! !

!S2MembersView methodsFor: 'rendering' stamp: 'AQ 9/6/2008 13:13'!
renderContentOn: html 
	html heading: 'Members'.
	view viewedUser isNil 
		ifTrue: 
			[ html table: 
				[ html tableHead: 
					[ html
						tableHeading: 'Name';
						tableHeading: 'Initials';
						tableHeading: 'Projects';
						tableHeading: 'Groups';
						tableHeading: 'Tags';
						tableHeading: 'Commits' ].
				self s2root users do: 
					[ :each | 
					html tableRow: 
						[ html tableData: 
							[ html anchor
								callback: [ self viewUser: each ];
								with: each title ].
						html tableData: each name.
						html tableData: (self s2root countProjectsOfUser: each).
						html tableData: (self s2root groupsOfUser: each).
						html tableData: each tags ] ] ] ]
		ifFalse: [ html render: view ]! !

!S2MembersView methodsFor: 'accessing' stamp: 'AQ 8/26/2008 20:48'!
view
	^ view! !

!S2MembersView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:43'!
view: aUser 
	view := aUser! !

!S2MembersView methodsFor: 'actions' stamp: 'AQ 8/26/2008 20:56'!
viewUser: aUser 
	view viewedUser: aUser! !

S2ContentComponent subclass: #S2ProjectView
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2ProjectView methodsFor: 'actions' stamp: 'AQ 9/3/2008 13:43'!
delete: aProject 
	self s2root removeProject: aProject! !

!S2ProjectView methodsFor: 'actions' stamp: 'AQ 9/3/2008 13:43'!
edit
	self call: (project asComponent addValidatedForm; addMessage: 'Edit Project'; yourself)! !

!S2ProjectView methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:41'!
project
	^ project! !

!S2ProjectView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:43'!
project: aProject 
	project := aProject! !

!S2ProjectView methodsFor: 'rendering' stamp: 'AQ 9/3/2008 13:43'!
renderContentOn: html 
	html heading: 'Project ' , project title.
	(self project isEditableBy: self session user)
		ifTrue: [html anchor
				callback: [self edit];
				 with: 'Edit'.
			html break.
			html anchor
				callback: [self delete: self project];
				 with: 'Delete']! !

S2ContentComponent subclass: #S2ProjectsView
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2ProjectsView methodsFor: 'accessing' stamp: 'AQ 8/20/2008 18:46'!
children
	^ Array with: view! !

!S2ProjectsView methodsFor: 'initialization' stamp: 'AQ 9/6/2008 13:55'!
initialize
	super initialize.
	view := S2ProjectView on: self.! !

!S2ProjectsView methodsFor: 'rendering' stamp: 'AQ 9/6/2008 12:12'!
renderContentOn: html 
	html heading: 'Projects'.
	view project isNil
		ifTrue: [html
				table: [html
						tableHead: [html tableHeading: 'Projectname';
								 tableHeading: 'Admins';
								 tableHeading: 'Developers';
								 tableHeading: 'Tags';
								 tableHeading: 'Activity';
								 tableHeading: 'Downloads'].
					self s2root projects
						do: [:each | html
								tableRow: [html
										tableData: [html anchor
												callback: [self viewProject: each];
												 with: each title].
									html
										tableData: [each admins
												do: [:ea | html text: ea name]].
									html
										tableData: [each developers
												do: [:ea | html text: ea name]].
									html
										tableData: (each tags) ]]]]
		ifFalse: [html render: view]! !

!S2ProjectsView methodsFor: 'actions' stamp: 'AQ 9/3/2008 13:45'!
viewProject: aProject 
	view project: aProject! !

S2ContentComponent subclass: #S2SearchView
	instanceVariableNames: 'searchInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2SearchView methodsFor: 'rendering' stamp: 'AQ 9/5/2008 18:11'!
renderContentOn: html 
	html heading: 'Search'.
	html
		form: [
			html textInput on: #searchInput of: self;
				 value: ''.
			html break.
			html submitButton text: 'Search';
				callback: [self search]]! !

!S2SearchView methodsFor: 'actions' stamp: 'AQ 9/5/2008 18:38'!
search
	| user view |
	user := self s2root userNamed: self searchInput.
	user notNil
		ifTrue: [
			view := S2UserView new.
			view viewedUser: user.
			self root content call: view]! !

!S2SearchView methodsFor: 'accessing' stamp: 'AQ 9/5/2008 18:10'!
searchInput
	^ searchInput! !

!S2SearchView methodsFor: 'accessing' stamp: 'AQ 9/5/2008 18:11'!
searchInput: aString
	searchInput := aString! !

S2ContentComponent subclass: #S2TagsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2TagsView methodsFor: 'rendering' stamp: 'AQ 9/3/2008 13:46'!
renderContentOn: html 
	html heading: 'Tags'! !

S2ContentComponent subclass: #S2UserView
	instanceVariableNames: 'viewedUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2UserView methodsFor: 'actions' stamp: 'AQ 9/2/2008 10:02'!
delete: aUser 
	self s2root removeUser: aUser.
	aUser = self session user
		ifTrue: [self session logout]! !

!S2UserView methodsFor: 'actions' stamp: 'AQ 7/15/2008 21:45'!
edit
	self call: (viewedUser
		asComponent
			addValidatedForm;
			addMessage: 'Edit User';
			yourself).! !

!S2UserView methodsFor: 'rendering' stamp: 'AQ 9/2/2008 10:06'!
renderContentOn: html 
	html heading: 'User ' , viewedUser title.
	(self viewedUser isEditableBy: self session user)
		ifTrue: [html anchor
				callback: [self edit];
				 with: 'Edit'.
			html break.
			html anchor
				callback: [self delete: self viewedUser];
				 with: 'Delete'.]! !

!S2UserView methodsFor: 'accessing' stamp: 'AQ 7/15/2008 21:44'!
viewedUser
	^ viewedUser! !

!S2UserView methodsFor: 'accessing' stamp: 'AQ 7/15/2008 21:44'!
viewedUser: anObject
	viewedUser := anObject! !

S2ContentComponent subclass: #S2WelcomeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2WelcomeView methodsFor: 'rendering' stamp: 'AQ 8/26/2008 16:33'!
renderContentOn: html
	html heading: 'Home'.
	html text: 'Welcome to SqueakSource 2'! !

S2Component subclass: #S2LeftMenuComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

S2LeftMenuComponent subclass: #S2LoginView
	instanceVariableNames: 'username password message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2LoginView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:47'!
hashPassword: aString 
	^ aString isEmptyOrNil
		ifFalse: [SecureHashAlgorithm new hashMessage: aString]! !

!S2LoginView methodsFor: 'accessing' stamp: 'AQ 8/17/2008 16:28'!
password
	^ password! !

!S2LoginView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:47'!
password: aString 
	password := self hashPassword: aString! !

!S2LoginView methodsFor: 'rendering' stamp: 'AQ 9/6/2008 14:25'!
renderContentOn: html 
	html paragraph: message.
	html
		form: [self session isLoggedIn
				ifFalse: [html text: 'Username: '.
					html textInput on: #username of: self;
						 value: ''.
					html break.
					html text: 'Password: '.
					html passwordInput
						callback: [:value | self password: value];
						 value: ''.
					html break.
					html submitButton text: 'Login';
						callback: [self validateLogin]].
			self session isLoggedIn
				ifTrue: [html text: self session user title.
					html break.
					html submitButton text: 'Logout';
						callback: [self session logout. self root content call: S2WelcomeView new.]]]! !

!S2LoginView methodsFor: 'accessing' stamp: 'AQ 8/17/2008 16:28'!
username
	^ username! !

!S2LoginView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:48'!
username: aString
	username := aString! !

!S2LoginView methodsFor: 'actions' stamp: 'AQ 9/3/2008 13:48'!
validateLogin
	"checks if login data is correct."
	| user |
	user := self s2root userNamed: username.
	user notNil
		ifTrue: [self password = user password
				ifTrue: [self session user: user.
					message := '']
				ifFalse: [message := 'USERNAME OR PASSWORD FALSE']]
		ifFalse: [message := 'USERNAME OR PASSWORD FALSE']! !

S2LeftMenuComponent subclass: #S2MessageComponent
	instanceVariableNames: 'messageType messageString wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2MessageComponent methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:49'!
aMessage: aString 
	self messageString = aString.
	wasShown = false! !

!S2MessageComponent methodsFor: 'initialization' stamp: 'AQ 9/3/2008 13:49'!
initialize
	super initialize.
	wasShown := true! !

!S2MessageComponent methodsFor: 'rendering' stamp: 'AQ 9/3/2008 13:49'!
renderContentOn: html 
	self wasShown
		ifTrue: [^ self].
	html test: self messageString! !

S2LeftMenuComponent subclass: #S2UserMenuComponent
	instanceVariableNames: 'projectView groupView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2UserMenuComponent methodsFor: 'actions' stamp: 'AQ 9/5/2008 15:35'!
editAccount
	| view |
	view := S2UserView new.
	view viewedUser: self session user.
	self root content call: view.! !

!S2UserMenuComponent methodsFor: 'actions' stamp: 'AQ 9/3/2008 16:33'!
editRoot
	self root content call: (self s2root
		asComponent
			addValidatedForm;
			addMessage: 'Edit Root';
			yourself).! !

!S2UserMenuComponent methodsFor: 'initialization' stamp: 'AQ 9/6/2008 14:05'!
initialize
	super initialize.
	projectView := S2ProjectView on: self.
	groupView := S2GroupView on: self.! !

!S2UserMenuComponent methodsFor: 'actions' stamp: 'AQ 9/3/2008 16:35'!
newGroup
	| newGroup |
	newGroup := self root content call: (S2Group new asComponent addValidatedForm; addMessage: 'Create Group'; yourself).
	newGroup isNil
		ifFalse: [self s2root addGroup: newGroup.
			newGroup addAdmin: self session user]! !

!S2UserMenuComponent methodsFor: 'actions' stamp: 'AQ 9/3/2008 16:20'!
newProject
	| newProject |
	newProject := self root content call: (S2Project new asComponent addValidatedForm; addMessage: 'Create Project'; yourself).
	newProject isNil not & self session user isAnonymous not
		ifTrue: [self s2root addProject: newProject.
			(newProject addAdmin: self session user)].! !

!S2UserMenuComponent methodsFor: 'actions' stamp: 'AQ 9/3/2008 16:18'!
newUser
	| newUser |
	newUser := self root content call: (S2User new
		asComponent
			addValidatedForm;
			addMessage: 'Create User Account';
			yourself).
	newUser isNil
		ifFalse: [ self s2root addUser: newUser.
			self session user: newUser].! !

!S2UserMenuComponent methodsFor: 'accessing' stamp: 'AQ 9/6/2008 13:29'!
projectView
	^ projectView! !

!S2UserMenuComponent methodsFor: 'accessing' stamp: 'AQ 9/6/2008 13:29'!
projectView: anObject
	projectView := anObject! !

!S2UserMenuComponent methodsFor: 'rendering' stamp: 'AQ 9/6/2008 14:05'!
renderContentOn: html 
	self session isLoggedIn
		ifTrue: [
			html anchor
				callback: [self editAccount];
				 with: 'Edit Account'.
			html break; break.
			html text: 'Projects'.
			html break.
			(self s2root getProjectsOfUser: (self session user)) do: [:each | html anchor callback: [self viewProject: each]; with: (each title). html break].
			html break.
			html text: 'Groups'.
			html break.
			(self s2root getGroupsOfUser: (self session user)) do: [:each | html anchor callback: [self viewGroup: each]; with: (each title). html break].
			html break.
			html anchor
				callback: [self newProject];
				 with: 'New Project'.
			html break.
			html anchor
				callback: [self newGroup];
				 with: 'New Group']
		ifFalse: [
			html anchor
				callback: [self newUser];
				 with: 'New User'].
	self session user superuser
		ifTrue: [
			html break.
			html anchor
				callback: [self editRoot];
				 with: 'Edit Root']! !

!S2UserMenuComponent methodsFor: 'actions' stamp: 'AQ 9/6/2008 14:06'!
viewGroup: aGroup
	groupView group: aGroup.
	self root content call: groupView.! !

!S2UserMenuComponent methodsFor: 'actions' stamp: 'AQ 9/6/2008 14:03'!
viewProject: aProject
	projectView project: aProject.
	self root content call: projectView.! !

S2Component subclass: #S2MenuComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2MenuComponent methodsFor: 'rendering' stamp: 'AQ 9/5/2008 15:10'!
renderContentOn: html
	html anchor
		callback: [self root content call: (S2WelcomeView new asComponent)];
		 with: 'Home'.
	html anchor
		callback: [self root content call: S2ProjectsView new asComponent];
		 with: 'Projects'.
	html anchor
		callback: [self root content call: S2TagsView new asComponent];
		 with: 'Tags'.
	html anchor
		callback: [self root content call: S2SearchView new asComponent];
		 with: 'Search'.
	html anchor
		callback: [self root content call: S2MembersView new asComponent];
		 with: 'Members'.
	html anchor
		callback: [self root content call: S2GroupsView new asComponent];
		 with: 'Groups'.
	html anchor
		callback: [self root content call: S2HelpView new asComponent];
		 with: 'Help'.! !

WAComponent subclass: #S2RootComponent
	instanceVariableNames: 'content userMenu login menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2RootComponent class methodsFor: 'testing' stamp: 'AQ 8/20/2008 14:52'!
canBeRoot
	^ true! !

!S2RootComponent class methodsFor: 'initialization' stamp: 'AQ 8/20/2008 14:52'!
initialize
	| application |
	application := self registerAsApplication: 'squeaksource'.
	application preferenceAt: #sessionClass put: S2Session.! !

!S2RootComponent methodsFor: 'accessing' stamp: 'AQ 9/5/2008 15:07'!
children
	^ Array with: content with: userMenu with: login with: menu.! !

!S2RootComponent methodsFor: 'accessing' stamp: 'AQ 9/3/2008 16:10'!
content
	^ content! !

!S2RootComponent methodsFor: 'accessing' stamp: 'AQ 8/20/2008 17:50'!
content: aComponent
	content:= aComponent! !

!S2RootComponent methodsFor: 'initialization' stamp: 'AQ 9/5/2008 15:07'!
initialize
	super initialize.
	content := S2WelcomeView on: self.
	login := S2LoginView on: self.
	userMenu := S2UserMenuComponent on: self.
	menu := S2MenuComponent on: self.! !

!S2RootComponent methodsFor: 'rendering' stamp: 'AQ 9/6/2008 13:19'!
renderContentOn: html 
	html heading: self s2root title.
	html render: menu.
	html break.
	html render: login.
	html break.
	html render: userMenu.
	html break.
	html render: content! !

!S2RootComponent methodsFor: 'updating' stamp: 'lr 9/2/2008 11:11'!
updateRoot: html
	html title: self s2root title.! !

!S2RootComponent methodsFor: 'actions' stamp: 'AQ 7/15/2008 21:48'!
viewUser: aUser
	content := S2UserView on: self.
	content viewedUser: aUser.! !

WASession subclass: #S2Session
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-View'!

!S2Session methodsFor: 'initialization' stamp: 'lr 8/19/2008 11:44'!
initialize
	super initialize.
	self logout.! !

!S2Session methodsFor: 'testing' stamp: 'AQ 8/20/2008 14:50'!
isLoggedIn
	^ self user isAnonymous not! !

!S2Session methodsFor: 'accessing' stamp: 'AQ 8/17/2008 21:03'!
login: aUser 
	self user: aUser! !

!S2Session methodsFor: 'accessing' stamp: 'AQ 9/6/2008 14:24'!
logout
	self user: self s2root anonymous.! !

!S2Session methodsFor: 'accessing' stamp: 'AQ 8/17/2008 17:38'!
user
	^ user! !

!S2Session methodsFor: 'accessing' stamp: 'AQ 8/20/2008 14:46'!
user: aS2Person 
	user := aS2Person! !

TestCase subclass: #S2EntryTest
	instanceVariableNames: 'entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2EntryTest methodsFor: 'running' stamp: 'AQ 7/6/2008 17:47'!
setUp
	entry := S2Entry new.! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:40'!
testAddTags
	self assert: (entry tags isEmpty).
	
	entry addTag: 'seaside'.
	self assert: (entry tags anyOne = 'seaside').
	self assert: (entry tags size = 1)! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:56'!
testName
	entry name: 'SqueakSource2'.
	self assert: (entry name = 'SqueakSource2').
	self deny: (entry name = 'Unnamed')! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:39'!
testRemoveTags
	self assert: (entry tags isEmpty).
	
	entry addTag: 'seaside'.
	self assert: (entry tags anyOne = 'seaside').
	
	entry removeTag: 'seaside'.
	self assert: (entry tags isEmpty)! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:55'!
testTitle
	entry title: 'SqueakSource 2'.
	self assert: (entry title = 'SqueakSource 2').
	self deny: (entry title = 'Unnamed')! !

!S2EntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:54'!
testWiki
	entry wiki: 'aWiki'.
	self assert: (entry wiki = 'aWiki').
	self deny: (entry wiki = 'wikipedia')! !

TestCase subclass: #S2GroupTest
	instanceVariableNames: 'user superuser user2 group admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2GroupTest methodsFor: 'running' stamp: 'AQ 7/9/2008 12:17'!
setUp
	user := S2User new.
	superuser := S2User new.
	superuser superuser: true.
	admin := S2User new.
	user2 := S2User new.
	group := S2Group new.! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:27'!
testAddAdmin
	self assert: user groups isEmpty.
	self assert: group admins isEmpty.
	
	group addAdmin: admin..
	
	self assert: admin groups size = 1.
	self assert: admin groups anyOne = group.
	self assert: group admins size = 1.
	self assert: group admins anyOne = admin.! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:26'!
testAddUser
	self assert: user groups isEmpty.
	self assert: group users isEmpty.
	
	group addUser: user.
	
	self assert: user groups size = 1.
	self assert: user groups anyOne = group.
	self assert: group users size = 1.
	self assert: group users anyOne = user! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:23'!
testIsEditableBy
	group addUser: user.
	group addAdmin: admin.
	
	self deny: (group isEditableBy: user).
	self assert: (group isEditableBy: admin).
	self deny: (group isEditableBy: user2).
	self assert: (group isEditableBy: superuser).
	! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:35'!
testIsVisibleBy
	group addUser: user.
	group addAdmin: admin.
	
	self assert: (group isVisibleBy: user).
	self assert: (group isVisibleBy: admin).
	self deny: (group isVisibleBy: user2).
	self assert: (group isVisibleBy: superuser).
	! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:28'!
testRemoveAdmin
	group addAdmin: admin.
	self assert: admin groups size = 1.
	self assert: group admins size = 1.
	group removeAdmin: admin.
	self assert: group admins size = 0.
	self assert: admin groups size = 0! !

!S2GroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:27'!
testRemoveUser
	group addUser: user.
	self assert: user groups size = 1.
	self assert: group users size = 1.
	group removeUser: user.
	self assert: group users size = 0.
	self assert: user groups size = 0! !

TestCase subclass: #S2MemberTest
	instanceVariableNames: 'user group project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2MemberTest methodsFor: 'running' stamp: 'AQ 7/6/2008 20:07'!
setUp
	user := S2User new.
	group := S2Group new.
	project := S2Project new! !

!S2MemberTest methodsFor: 'tests' stamp: 'lr 6/30/2008 14:47'!
testUserAddGroup
	self assert: user groups isEmpty.
	self assert: group users isEmpty.
	
	user addGroup: group.
	
	self assert: user groups size = 1.
	self assert: user groups anyOne = group.
	self assert: group users size = 1.
	self assert: group users anyOne = user! !

!S2MemberTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 19:48'!
testUserRemoveGroup
	user addGroup: group.
	self assert: user groups size = 1.
	self assert: group users size = 1.
	
	user removeGroup: group.
	self assert: user groups size = 0.
	self assert: group users size = 0! !

TestCase subclass: #S2ProjectTest
	instanceVariableNames: 'group project superuser admin developer user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2ProjectTest methodsFor: 'running' stamp: 'AQ 7/9/2008 12:53'!
setUp
	developer := S2User new.
	admin := S2User new.
	user := S2User new.
	superuser := S2User new.
	superuser superuser: true.
	group := S2Group new.
	project := S2Project new! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/12/2008 22:02'!
testAddAdmin
	self assert: project admins isEmpty.
	project addAdmin: admin.
	self assert: project admins size = 1.
	project addAdmin: group.
	self assert: project admins size = 2.! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/12/2008 22:02'!
testAddDeveloper
	self assert: project developers isEmpty.
	project addDeveloper: developer.
	self assert: project developers size = 1.
	project addDeveloper: group.
	self assert: project developers size = 2.! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:52'!
testIsEditableBy
	project addAdmin: admin.
	project addDeveloper: developer.
	
	self assert: (project isEditableBy: admin).
	self assert: (project isEditableBy: superuser).
	self deny: (project isEditableBy: developer).
	self deny: (project isEditableBy: user).! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 13:36'!
testIsVisibleBy
	project addAdmin: admin.
	project addDeveloper: developer.
	
	self assert: (project isVisibleBy: admin).
	self assert: (project isVisibleBy: superuser).
	self assert: (project isVisibleBy: developer).
	self deny: (project isVisibleBy: user).
	
	project visibility: #visible.
	self assert: (project isVisibleBy: user).! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:19'!
testLicense
	self deny: project license = 'gnu'.
	project license: 'gnu'.
	self assert: project license = 'gnu'.! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:24'!
testRating
	self assert: project rating = 0.
	project rating: 5.5.
	self assert: project rating = 5.5
	! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/12/2008 22:03'!
testRemoveAdmin
	project addAdmin: group.
	project addAdmin: admin.
	self assert: project admins size = 2.
	self deny: project admins isEmpty.
	project removeAdmin: group.
	self assert: project admins size = 1.
	self deny: project admins isEmpty.
	project removeAdmin: admin.
	self assert: project admins size = 0.
	self assert: project admins isEmpty.! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/12/2008 22:04'!
testRemoveDeveloper
	project addDeveloper: group.
	project addDeveloper: developer.
	self assert: project developers size = 2.
	self deny: project developers isEmpty.
	project removeDeveloper: group.
	self assert: project developers size = 1.
	self deny: project developers isEmpty.
	project removeDeveloper: developer.
	self assert: project developers size = 0.
	self assert: project developers isEmpty.! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:22'!
testState
	self assert: project state = 'Created'.
	project state: 'Alpha'.
	self assert: project state = 'Alpha'.
	self deny: project state = 'Created'.
	! !

!S2ProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:59'!
testVisibility
	self deny: project visibility = #writable.
	self deny: project visibility = #visible.
	self assert: project visibility = #hidden.
	project visibility: #visible.
	self assert: project visibility = #visible.
	! !

TestCase subclass: #S2RootTest
	instanceVariableNames: 'root user group project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2RootTest methodsFor: 'running' stamp: 'AQ 7/6/2008 20:39'!
setUp
	root := S2Root new.
	group := S2Group new.
	user := S2User new.
	project := S2Project new
	! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:44'!
testAddGroup
	self assert: root groups isEmpty.
	root addGroup: group.
	self assert: root groups size = 1.
	self assert: root groups anyOne = group! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:45'!
testAddProject
	self assert: root projects isEmpty.
	root addProject: project.
	self assert: root projects size = 1.
	self assert: root projects anyOne = project! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:46'!
testAddUser
	self assert: root users isEmpty.
	root addUser: user.
	self assert: root users size = 1.
	self assert: root users anyOne = user! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 13:13'!
testCountProjectsOfUser
	root addUser: user.
	self assert: root users size = 1.
	root addProject: project.
	project addAdmin: user.
	self assert: root projects size = 1.
	self assert: (root countProjectsOfUser: user) = 1! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 14:19'!
testGetGroupsOfUser
	root addUser: user.
	self assert: root users size = 1.
	root addGroup: group.
	group addAdmin: user.
	self assert: root groups size = 1.
	self assert: (root getGroupsOfUser: user) anyOne = group.
	root removeGroup: group.
	self assert: (root getGroupsOfUser: user) isEmpty.! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 14:17'!
testGetProjectsOfUser
	root addUser: user.
	self assert: root users size = 1.
	root addProject: project.
	project addAdmin: user.
	self assert: root projects size = 1.
	self assert: (root getProjectsOfUser: user) anyOne = project.
	root removeProject: project.
	self assert: (root getProjectsOfUser: user) isEmpty.! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:50'!
testRemoveGroup
	root addGroup: group.
	self assert: root groups size = 1.
	root removeGroup: group.
	self assert: root groups size = 0! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:52'!
testRemoveProject
	root addProject: project.
	self assert: root projects size = 1.
	root removeProject: project.
	self assert: root projects size = 0! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 13:11'!
testRemoveUser
	root addUser: user.
	self assert: root users size = 1.
	root removeUser: user.
	self assert: root users size = 0.! !

!S2RootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 13:15'!
testUserNamed
	root addUser: user.
	self assert: root users size = 1.
	self assert: (root userNamed: user name) = user.! !

TestCase subclass: #S2UserTest
	instanceVariableNames: 'user superuser user2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource2-Tests'!

!S2UserTest methodsFor: 'running' stamp: 'AQ 7/9/2008 11:54'!
setUp
	user := S2User new.
	superuser := S2User new.
	superuser superuser: true.
	user2 := S2User new.! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:15'!
testEmail
	self deny: user email = 'e@mail.net'.
	user email: 'e@mail.net'.
	self assert: user email = 'e@mail.net'! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 11:55'!
testIsEditableBy
	self assert: (user isEditableBy: user).
	self deny: (user isEditableBy: user2).
	self assert: (user isEditableBy: superuser).! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:33'!
testIsVisibleBy
	self assert: (user isVisibleBy: user).
	self assert: (user isVisibleBy: user2).
	self assert: (user isVisibleBy: superuser).! !

!S2UserTest methodsFor: 'tests' stamp: 'lr 7/9/2008 15:02'!
testPassword
	user password: '12345'.
	self assert: (user verifyPassword: '12345').
	self deny: (user verifyPassword: '1234')! !

!S2UserTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:18'!
testSuperuser
	self deny: user superuser.
	user superuser: true.
	self assert: user superuser! !
S2Root initialize!
S2RootComponent initialize!
